require_relative 'testrail_extensions'
module Cucumber #:nodoc: 
  module Ast #:nodoc:
    class Scenario
      include Testrail::Scenario
      ##
      # return the steps and as strings ready to write to the testcase
      def steps_as_string
        to_sexp.select{|a| a[0]==:step_invocation}.map do |s|
          if s[4]
            ["#{s[2]}#{s[3]}"]+s[4].select{|e| e.is_a?(Array) && e[0]==:row}.map do |l|
              "| #{l.select{|e| e.is_a?(Array)}.map{|e| e[1]}.join(' | ')} |"
            end
          else  
            "#{s[2]}#{s[3]}"
          end
        end.flatten.join("\n")
      end

      def tag_line
        line - 2
      end
    end

    class ScenarioOutline
      def my_steps
        @steps ||= @background.step_collection(step_invocations)
      end
    end

    class OutlineTable
      class ExampleRow
        include Testrail::Scenario

        def feature_tags
          scenario_outline.feature_tags
        end

        def title
          line = self.to_hash.to_a.map{|a| "#{a[0]}='#{a[1]}'"}.join(', ')
          "#{scenario_outline.title} :: #{line}"
        end  

        def steps_as_string
          #example rows in an outline table don't respond to steps so we have to check the scenario_outline
          scenario_outline.raw_steps.map{|s| "#{s.keyword} #{s.name}"}.join("\n")
        end

        def tag_line
          scenario_outline.file_colon_line.split(':')[1].to_i - 2
        end
        def file
          scenario_outline.file
        end  
      end
    end
  end  
end
